package ru.dbotthepony.mc.otm.block.entity.worker;

import net.minecraft.MethodsReturnNonnullByDefault;
import net.minecraft.util.StringRepresentable;
import net.minecraft.world.level.block.state.properties.EnumProperty;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public enum WorkerState implements StringRepresentable {
	IDLE,
	WORKING,
	ERROR;

	public static final EnumProperty<WorkerState> WORKER_STATE = EnumProperty.create("worker", WorkerState.class);
	public static final EnumProperty<WorkerState> SEMI_WORKER_STATE = EnumProperty.create("worker", WorkerState.class, IDLE, WORKING);

	@Override
	@Nonnull
	public String getSerializedName() {
		return this == IDLE ? "idle" : this == WORKING ? "working" : "error";
	}
}
