package ru.dbotthepony.mc.otm.client.render;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.renderer.GameRenderer;
import net.minecraft.client.renderer.MultiBufferSource;
import net.minecraft.client.renderer.blockentity.BlockEntityRenderer;
import net.minecraft.client.renderer.blockentity.BlockEntityRendererProvider;
import net.minecraft.world.phys.Vec3;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityBlackHole;

import static org.lwjgl.opengl.GL33.*;

public class BlackHoleRenderer implements BlockEntityRenderer<BlockEntityBlackHole> {
	@Override
	public void render(BlockEntityBlackHole blockEntityBlackHole, float v, PoseStack poseStack, MultiBufferSource multiBufferSource, int i, int i1) {
		RenderHelper.setDrawColor(RGBAColor.BLACK);

		RenderSystem.setShader(GameRenderer::getPositionColorShader);
		RenderSystem.depthFunc(GL_LESS);
		RenderSystem.depthMask(true);

		RenderSystem.enableDepthTest();
		RenderSystem.disableCull();

		poseStack.pushPose();
		poseStack.translate(0.5, -blockEntityBlackHole.getGravitationStrength() / 2 + 0.5, 0.5);

		RenderHelper.colorSphere(poseStack, (float) blockEntityBlackHole.getGravitationStrength());

		poseStack.popPose();

		RenderSystem.enableCull();
		RenderSystem.enableTexture();
	}

	@Override
	public boolean shouldRenderOffScreen(BlockEntityBlackHole p_112306_) {
		return true;
	}

	@Override
	public boolean shouldRender(BlockEntityBlackHole p_173568_, Vec3 p_173569_) {
		return true;
	}

	@Override
	public int getViewDistance() {
		return 512;
	}

	public BlackHoleRenderer(BlockEntityRendererProvider.Context context) {

	}
}
