package ru.dbotthepony.mc.otm.client.screen;

import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel;
import ru.dbotthepony.mc.otm.client.screen.panels.FlexGridPanel;
import ru.dbotthepony.mc.otm.client.screen.panels.SlotPanel;
import ru.dbotthepony.mc.otm.client.screen.widget.PowerGaugePanel;
import ru.dbotthepony.mc.otm.menu.DriveRackMenu;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;

import java.util.List;

public class DriveRackScreen extends MatteryScreen<DriveRackMenu> implements MatteryScreen.IMatteryScreenGaugeGetter, MatteryScreen.IMatteryScreenBatteryGetter, MatteryScreen.IMatteryScreenGridBased {
	public DriveRackScreen(DriveRackMenu menu, Inventory inventory, Component title) {
		super(menu, inventory, title);
	}

	@Override
	public List<EditablePanel> getGauges() {
		return List.of(new PowerGaugePanel(this, null, menu.battery_widget));
	}

	@Override
	public List<MatterySlot> getBatterySlots() {
		return List.of(menu.battery_slot);
	}

	@Override
	public void createGridPanels(FlexGridPanel grid) {
		for (var slot : menu.drives)
			new SlotPanel<>(this, grid, slot);
	}
}
