package ru.dbotthepony.mc.otm.client.screen;

import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.client.screen.widget.MatterGaugePanel;
import ru.dbotthepony.mc.otm.client.screen.widget.PowerGaugePanel;
import ru.dbotthepony.mc.otm.client.screen.widget.ProgressGaugePanel;
import ru.dbotthepony.mc.otm.menu.MatterReplicatorMenu;
import ru.dbotthepony.mc.otm.menu.slot.MatterySlot;
import ru.dbotthepony.mc.otm.client.screen.panels.*;

import java.util.List;

public class MatterReplicatorScreen extends MatteryScreen<MatterReplicatorMenu> implements MatteryScreen.IMatteryScreenGaugeGetter, MatteryScreen.IMatteryScreenBatteryGetter, MatteryScreen.IMatteryScreenGridBased {
	public MatterReplicatorScreen(MatterReplicatorMenu p_97741_, Inventory p_97742_, Component p_97743_) {
		super(p_97741_, p_97742_, p_97743_);
	}

	@Override
	public List<EditablePanel> getGauges() {
		return List.of(new PowerGaugePanel(this, null, menu.battery_widget), new MatterGaugePanel(this, null, menu.matter_widget));
	}

	@Override
	public List<MatterySlot> getBatterySlots() {
		return List.of(menu.battery_slot);
	}

	@Override
	public void createGridPanels(FlexGridPanel grid) {
		new ProgressGaugePanel(this, grid, menu.progress).setDockMargin(2, 0, 2, 0);

		for (var slot : menu.output_slots) {
			new SlotPanel<>(this, grid, 0, 0, slot);
		}
	}
}
