package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterCapacitorBank;
import ru.dbotthepony.mc.otm.capability.matter.IMatterHandler;
import ru.dbotthepony.mc.otm.core.Fraction;
import ru.dbotthepony.mc.otm.menu.slot.MatterContainerInputSlot;
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget;

import java.math.BigDecimal;

public class MatterCapacitorBankMenu extends MatteryMenu {
	public MatterCapacitorBankMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public LevelGaugeWidget matter_widget;
	public LevelGaugeWidget total_matter_widget;

	public MatterContainerInputSlot[] container_slots = new MatterContainerInputSlot[2 * 6];

	public MatterCapacitorBankMenu(int p_38852_, Inventory inventory, BlockEntityMatterCapacitorBank tile) {
		super(Registry.Menus.MATTER_CAPACITOR_BANK, p_38852_, inventory, tile);

		if (tile == null) {
			matter_widget = new LevelGaugeWidget(this);
			total_matter_widget = new LevelGaugeWidget(this);
		} else {
			matter_widget = new LevelGaugeWidget(this, tile.matter);
			total_matter_widget = new LevelGaugeWidget(this, () -> {
				if (tile.getMatterGrid() != null) {
					return tile.getMatterGrid().getStored();
				}

				return Fraction.ZERO;
			}, () -> {
				if (tile.getMatterGrid() != null) {
					return tile.getMatterGrid().getCapacity();
				}

				return Fraction.ZERO;
			});
		}

		Container container = tile != null ? tile.matter_container : new SimpleContainer(2 * 6);

		for (int row = 0; row < 2; row++){
			for (int column = 0; column < 6; column++) {
				container_slots[row * 6 + column] = new MatterContainerInputSlot(container, row * 6 + column, 44 + column * 18, 20 + row * 18, true, IMatterHandler.MatterDirection.BIDIRECTIONAL);
				addSlot(container_slots[row * 6 + column]);
			}
		}

		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 2 * 6;
	}
}
