package ru.dbotthepony.mc.otm.network;

import net.minecraft.network.FriendlyByteBuf;

import java.math.BigDecimal;
import java.math.BigInteger;

public class NetworkHelper {
	public static BigDecimal readDecimal(FriendlyByteBuf buffer) {
		int scale = buffer.readInt();
		int length = buffer.readByte() & 0xFF;
		byte[] bytes = new byte[length];

		for (int i = 0; i < length; i++)
			bytes[i] = buffer.readByte();

		return new BigDecimal(new BigInteger(bytes), scale);
	}

	public static void writeDecimal(FriendlyByteBuf buffer, BigDecimal value) {
		buffer.writeInt(value.scale());
		byte[] build = value.unscaledValue().toByteArray();
		buffer.writeByte(build.length);
		for (byte b : build) buffer.writeByte(b);
	}

	public static short[] bytesToShorts(byte[] input) {
		if (input.length % 2 != 0) {
			short[] values = new short[input.length / 2 + 1];

			for (int i = 0; i < values.length - 1; i++)
				values[i] = (short) ((input[i * 2] & 0xFF) | (input[i * 2 + 1] & 0xFF) << 8);

			values[values.length - 1] = input[input.length - 1];
			return values;
		}

		short[] values = new short[input.length / 2];

		for (int i = 0; i < values.length; i++)
			values[i] = (short) ((input[i * 2] & 0xFF) | (input[i * 2 + 1] & 0xFF) << 8);

		return values;
	}

	public static byte[] shortsToBytes(short[] input) {
		byte[] values = new byte[input.length * 2];

		for (int i = 0; i < input.length; i++) {
			values[i * 2] = (byte) (input[i] & 0xFF);
			values[i * 2 + 1] = (byte) ((input[i] & 0xFF00) >> 8);
		}

		return values;
	}
}
