package ru.dbotthepony.mc.otm.capability

import net.minecraftforge.energy.IEnergyStorage
import ru.dbotthepony.mc.otm.core.Fraction

fun IEnergyStorage.receiveEnergy(amount: Fraction, simulate: Boolean): Int {
	if (amount.isZero())
		return 0

	if (amount > Fraction.INT_MAX_VALUE)
		return receiveEnergy(Int.MAX_VALUE, simulate)

	return receiveEnergy(amount.wholePart().toInt(), simulate)
}

fun IEnergyStorage.extractEnergy(amount: Fraction, simulate: Boolean): Int {
	if (amount.isZero())
		return 0

	if (amount > Fraction.INT_MAX_VALUE)
		return extractEnergy(Int.MAX_VALUE, simulate)

	return extractEnergy(amount.wholePart().toInt(), simulate)
}
