package ru.dbotthepony.mc.otm.menu.data

import net.minecraft.world.inventory.ContainerData

class BooleanDataContainer : ContainerData {
	val buffer = intArrayOf(0)

	var value: Boolean
		get() = buffer[0] > 0
		set(value) { buffer[0] = if (value) 1 else 0 }

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 1
	}
}

class ShortDataContainer : ContainerData {
	val buffer = intArrayOf(0)

	var value: Short
		get() = buffer[0].toShort()
		set(value) { buffer[0] = value.toInt() }

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 1
	}
}

class ByteDataContainer : ContainerData {
	val buffer = intArrayOf(0)

	var value: Byte
		get() = buffer[0].toByte()
		set(value) { buffer[0] = value.toInt() }

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 1
	}
}

class IntDataContainer : ContainerData {
	val buffer = intArrayOf(0, 0)

	var value: Int
		get() {
			return buffer[0] or (buffer[1] shl 16)
		}
		set(value) {
			buffer[0] = value and 0xFFFF
			buffer[1] = value ushr 16
		}

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 2
	}
}

class LongDataContainer : ContainerData {
	val buffer = intArrayOf(0, 0, 0, 0)

	var value: Long
		get() {
			val a = buffer[0].toLong()
			val b = buffer[1].toLong()
			val c = buffer[2].toLong()
			val d = buffer[3].toLong()

			return a or (b shl 16) or (c shl 32) or (d shl 48)
		}
		set(value) {
			buffer[0] = (value and 0xFFFF).toInt()
			buffer[1] = ((value ushr 16) and 0xFFFF).toInt()
			buffer[2] = ((value ushr 32) and 0xFFFF).toInt()
			buffer[3] = ((value ushr 48) and 0xFFFF).toInt()
		}

	override fun get(p_39284_: Int): Int {
		return buffer[p_39284_]
	}

	override fun set(p_39285_: Int, p_39286_: Int) {
		buffer[p_39285_] = p_39286_
	}

	override fun getCount(): Int {
		return 4
	}
}
